//+------------------------------------------------------------------+
//|                                     Ericsoh iMTFStochSignals.mq4 |
//|                                                         SwingMan |
//+------------------------------------------------------------------+
#property copyright "Ericsoh"

#property indicator_chart_window

#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Blue   // EntryLong
#property indicator_color4 Red    // EntryShort

//--------------------------------------------------------------------
extern int Period_SMA1=13;
extern int Period_SMA2=21;
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;
//--------------------------------------------------------------------

int MAMethod   = 0;
int PriceField = 1;
//---- variables
double SMA1[], SMA2[];
double EntryLong[], EntryShort[];
double Stoch0This[], Stoch1This[];
double Stoch0Upper[], Stoch1Upper[];
int ThisTF;
int UpperTF = 1440;
int EntryDirection, OldDirection = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   ArraySetAsSeries(Stoch0This,true);
   ArraySetAsSeries(Stoch1This,true);
   ArraySetAsSeries(Stoch0Upper,true);   
   ArraySetAsSeries(Stoch1Upper,true);   
     
   ThisTF = Period();
//---- indicators
   SetIndexBuffer(0,SMA1);
   SetIndexBuffer(1,SMA2);
   SetIndexBuffer(2,EntryLong);
   SetIndexBuffer(3,EntryShort);   
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);      
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(2,DRAW_ARROW,EMPTY,1);      
   SetIndexStyle(3,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(2,233); // EntryLong
   SetIndexArrow(3,234); // EntryShort
   
   SetIndexLabel(0,"SMA1");
   SetIndexLabel(1,"SMA2");
   SetIndexLabel(2,"EntryLong");
   SetIndexLabel(3,"EntryShort");      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0;
   int    counted_bars=IndicatorCounted();
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),UpperTF);  
   
   ArrayResize(Stoch0This,Bars);
   ArrayResize(Stoch1This,Bars);
   ArrayResize(Stoch0Upper,Bars);   
   ArrayResize(Stoch1Upper,Bars);         
   
   limit=Bars-counted_bars;
   
   //---- moving averages
   for(i=0;i<limit;i++)
   {
     SMA1[i]=iMA(NULL,ThisTF,Period_SMA1,0,MODE_SMA,PRICE_TYPICAL,i);
     SMA2[i]=iMA(NULL,ThisTF,Period_SMA2,0,MODE_SMA,PRICE_TYPICAL,i);
   }
   
   //---- Stochastic signals
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
     
   Stoch0This[i]=iStochastic(NULL,ThisTF,KPeriod,DPeriod,Slowing,MAMethod,PriceField,0,i);
   Stoch1This[i]=iStochastic(NULL,ThisTF,KPeriod,DPeriod,Slowing,MAMethod,PriceField,1,i);
   
   Stoch0Upper[i]=iStochastic(NULL,UpperTF,KPeriod,DPeriod,Slowing,MAMethod,PriceField,0,y);
   Stoch1Upper[i]=iStochastic(NULL,UpperTF,KPeriod,DPeriod,Slowing,MAMethod,PriceField,1,y);

}   
   //---- signals
   for(i=limit;i>=0;i--)
   {
      //EntryDirection = 0;
      bool bLongEntry = (Stoch0This[i] > Stoch1This[i]) && (Stoch0Upper[i] >= Stoch1Upper[i]);
      if (bLongEntry) {
         EntryDirection = 1;
         if (EntryDirection != OldDirection){
            OldDirection = 1;
            EntryLong[i]  = Low[i] - 5*Point;
         }
      }
   
      bool bShortEntry = (Stoch0This[i] < Stoch1This[i]) && (Stoch0Upper[i] <= Stoch1Upper[i]);
      if (bShortEntry) {
         EntryDirection = -1;
         if (EntryDirection != OldDirection){
            OldDirection = -1;
            EntryShort[i] = High[i] + 5*Point;
         }
      }  
   }  

//----
   return(0);
  }
//+------------------------------------------------------------------+